#include <bits/stdc++.h>
 
using namespace std;
 
typedef long long ll;
typedef long double ld;
 
typedef vector<int> vi;
typedef vector<ll> vll;
 
typedef vector<vi> vvi;
typedef vector<vll> vvll;
 
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
 
typedef vector<pii> vpii;
typedef vector<pll> vpll;
 
typedef vector<vpii> vvpii;
typedef vector<vpll> vvpll;
 
#define pb push_back
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)(x).size()
#define fi first
#define se second
 
template<class T> bool ckmin(T &a, const T &b) {return a > b ? a = b, 1 : 0;}
template<class T> bool ckmax(T &a, const T &b) {return a < b ? a = b, 1 : 0;}
 
namespace debug {
    void __print(int x) {cerr << x;}
    void __print(long long x) {cerr << x;}
    void __print(double x) {cerr << x;}
    void __print(long double x) {cerr << x;}
    void __print(char x) {cerr << '\'' << x << '\'';}
    void __print(const string &x) {cerr << '\"' << x << '\"';}
    void __print(const char *x) {cerr << '\"' << x << '\"';}
    void __print(bool x) {cerr << (x ? "true" : "false");}
 
    template<typename T, typename V>
    void __print(const pair<T, V> &x) {cerr << '{'; __print(x.first); cerr << ','; __print(x.second); cerr << '}';}
    template<typename T>
    void __print(const T &x) {int f = 0; cerr << '{'; for(auto z : x) cerr << (f++ ? "," : ""), __print(z); cerr << "}";}
    void _print() {cerr << "]\n";}
    template <typename T, typename... V>
    void _print(T t, V... v) {__print(t); if(sizeof...(v)) cerr << ", "; _print(v...);}
 
#ifdef ljuba
#define dbg(x...) cerr << "\e[91m" << "LINE(" << __LINE__ << ") -> " << "[" << #x << "] = ["; _print(x)
#else
#define dbg(x...)
#endif
}
 
using namespace debug;
 
const char nl = '\n';
 
mt19937 rng(chrono::high_resolution_clock::now().time_since_epoch().count());
 
/*
???????? ?????? ???????, ??? ???? ??? ????????????? (????? ???? ???????? ?????) 
?????? ?? ????????? ???? ????? ????????? ?? ??????, ????????? ??????? ? ???????
*/

const int mxN = 3005;
int zarada[mxN][mxN];
int dp[mxN][mxN];

void solve() {
    string s;
    cin >> s;

    int n = sz(s);
    //za 100 poena mozda umesto da drzis dp[i][j] drzis samo dp[i][n-1]?

    for(int duz = 2; duz <= n; ++duz) {
        for(int i = 0; i + duz - 1 < n; ++i) {
            int l = i, r = i + duz - 1;
            if(duz % 2 == 1) {
                zarada[l][r] = 0;
            } else {
                zarada[l][r] = zarada[l+1][r-1] + (s[l] == s[r]);
            }
        }
    }

    for(int i = n-1; i >= 0; --i) {
        for(int k = 1; k < n; ++k) {
            int vel = 2*k;
            int idi = i + vel - 1;
            if(idi >= n) break;
            ckmax(dp[i][k], zarada[i][idi] + dp[i+k][k]);
        }
        for(int k = n-1; k >= 0; --k) {
            ckmax(dp[i][k], dp[i][k+1]);
        }
        for(int k = 0; k < n; ++k) {
            ckmax(dp[i][k], dp[i+1][k]);
        }
    }

    //for(int i = 0; i < n; ++i) {
        //for(int j = 0; j < n; ++j) {
            //dbg(i, j, dp[i][j]);
        //}
    //}

    int ans = 0;

    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < n; ++j) {
            ckmax(ans, dp[i][j]);
        }
    }

    cout << ans << nl;
}
 
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
 
    int testCases = 1;
    //cin >> testCases;
    while(testCases--)
        solve();
}